package chess.mobile;

import android.app.Application;

import chess.mobile.dao.UserSettingsDAO;
import chess.mobile.dao.UserSettingsDAOImpl;
import chess.mobile.rest.ServiceGenerator;
import com.crashlytics.android.Crashlytics;
import io.fabric.sdk.android.Fabric;
import uk.co.chrisjenx.calligraphy.CalligraphyConfig;

/**
 * Created by Stanisław Kabaciński.
 */

public class App extends Application {

    @Override
    public void onCreate() {
        super.onCreate();
        Fabric.with(this, new Crashlytics());
        CalligraphyConfig.initDefault(new CalligraphyConfig.Builder().build());
        UserSettingsDAO userSettingsDAO = new UserSettingsDAOImpl(this);
        ServiceGenerator.setBaseUrl(userSettingsDAO.getUrl());

    }
}
