package chess.mobile;

/**
 * Created by Stanisław Kabaciński.
 */

public interface Uci {

    String ID = "id";

    interface id {
        String NAME = "name";
        String AUTHOR = "author";

        String[] ALL =  {NAME, AUTHOR};
    }

    String UCI_OK = "uciok";
    String READY_OK = "readyok";
    String BEST_MOVE = "bestmove";
    String COPY_PROTECTION = "copyprotection";
    String REGISTRATION = "registration";
    String INFO = "info";

    interface info {
        String DEPTH = "depth";
        String SELDEPTH = "seldepth";
        String PV = "pv";
        String MULTIPV = "multipv";
        String SCORE = "score";

        interface score {
            String CP = "cp";
            String MATE = "mate";
            String LOWERBOUND = "lowerbound";
            String UPPERBOUND = "upperbound";

            String[] ALL = {CP, MATE, LOWERBOUND, UPPERBOUND};
        }

        String CURRMOVE = "currmove";
        String CURRMOVENUMBER = "currmovenumber";
        String HASHFULL = "hashfull";
        String NPS = "nps";
        String TBHITS = "tbhits";
        String CPULOAD = "cpuload";
        String STRING = "string";
        String REFUTATION = "refutation";
        String CURRLINE = "currline";

        String[] ALL = {
                DEPTH, SELDEPTH, PV, MULTIPV, SCORE, CURRMOVE, CURRMOVENUMBER, HASHFULL,
                NPS, TBHITS, CPULOAD, STRING, REFUTATION, CURRLINE
        };
    }

    String OPTION = "option";

    interface option {
        String NAME = "name";
        String TYPE = "type";

        interface type {
            String CHECK = "check";
            String SPIN = "spin";
            String COMBO = "combo";
            String BUTTON = "button";
            String STRING = "string";
        }

        String DEFAULT = "default";
        String MIN = "min";
        String MAX = "max";
        String VAR = "var";

        String[] ALL = {NAME, TYPE, DEFAULT, MIN, MAX, VAR};
    }

    String[] ALL = {ID, UCI_OK, READY_OK, BEST_MOVE, COPY_PROTECTION, REGISTRATION, INFO, OPTION};

}
