package chess.mobile.browsegames;

import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import java.util.List;

import chess.mobile.R;
import chess.mobile.model.SavedGameFileMeta;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

public class BrowseGamesAdapter extends RecyclerView.Adapter<SavedGameFileMetaViewHolder> {

    private OnItemClickListener<SavedGameFileMeta> onItemClickListener;
    private List<SavedGameFileMeta> dataSet;

    public BrowseGamesAdapter(OnItemClickListener<SavedGameFileMeta> onItemClickListener, List<SavedGameFileMeta> dataSet) {
        this.onItemClickListener = onItemClickListener;
        this.dataSet = dataSet;
    }

    @Override
    public SavedGameFileMetaViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        LayoutInflater layoutInflater = LayoutInflater.from(parent.getContext());
        return new SavedGameFileMetaViewHolder(layoutInflater.inflate(
                R.layout.item_saved_game_file_meta, parent, false
        ));
    }

    @Override
    public void onBindViewHolder(SavedGameFileMetaViewHolder holder, int position) {
        holder.bind(dataSet.get(holder.getAdapterPosition()), onItemClickListener);
    }

    @Override
    public int getItemCount() {
        return dataSet.size();
    }

    public List<SavedGameFileMeta> getDataSet() {
        return dataSet;
    }

    public void setDataSet(List<SavedGameFileMeta> dataSet) {
        this.dataSet = dataSet;
    }
}
