package chess.mobile.browsegames;

import java.util.List;

import chess.mobile.BasePresenter;
import chess.mobile.BaseView;
import chess.mobile.model.SavedGameFileMeta;

/**
 * Created by Stanisław Kabaciński.
 */

public interface BrowseGamesContract {

    interface View extends BaseView<Presenter> {

        void showSavedGames(List<SavedGameFileMeta> savedGames);

        void cannotRemoveGame();

        void notifyGameRemoved(int position);

        void openFile(String path);
    }

    interface Presenter extends BasePresenter {

        void removeFile(int position);

        void onGameSelected(SavedGameFileMeta object);

    }

}
