package chess.mobile.browsegames;

import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.widget.TextView;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import chess.mobile.R;
import chess.mobile.model.SavedGameFileMeta;
import chess.mobile.util.DateFormats;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */
public class SavedGameFileMetaViewHolder extends RecyclerView.ViewHolder implements View.OnClickListener {

    @BindView(R.id.name) TextView name;
    @BindView(R.id.date) TextView date;
    @BindView(R.id.path) TextView path;

    private SavedGameFileMeta model;
    private OnItemClickListener<SavedGameFileMeta> onItemClickListener;

    public SavedGameFileMetaViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);
        itemView.setOnClickListener(this);
    }

    public void bind(SavedGameFileMeta model, OnItemClickListener<SavedGameFileMeta> onItemClickListener) {
        this.onItemClickListener = onItemClickListener;
        this.model = model;

        name.setText(model.getName());
        date.setText(DateFormats.FORMAT_DEFAULT.format(model.getLastModified()));
        path.setText(model.getPath());
    }

    @OnClick(R.id.button)
    public void moreOnClick(View v) {
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), model);
        }
    }

    @Override
    public void onClick(View v) {
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), model);
        }
    }
}
