package chess.mobile.browsepgnfile;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;

import chess.mobile.R;
import chess.mobile.dao.SavedGamesDAOImpl;

import static butterknife.ButterKnife.findById;

public class BrowsePgnActivity extends AppCompatActivity {

    public static final String KEY_FILE_PATH = "file_path";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_browse_pgn_file);
        Toolbar toolbar = findById(this, R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        String filePath = getIntent().getStringExtra(KEY_FILE_PATH);

        BrowsePgnFragment fragment = new BrowsePgnFragment();
        new BrowsePgnPresenter(fragment, SavedGamesDAOImpl.getInstance(), filePath);

        getSupportFragmentManager().beginTransaction()
                .replace(R.id.fragment_container, fragment)
                .commit();
    }
}
