package chess.mobile.browsepgnfile;

import android.os.AsyncTask;

import java.util.List;

import chess.mobile.chessgame.pgn.PGNGame;
import chess.mobile.dao.SavedGamesDAO;

/**
 * Created 07.07.2017.
 */

class BrowsePgnPresenter implements BrowsePgnContract.Presenter {

    private BrowsePgnContract.View view;
    private String filePath;
    private LoadGames loadGamesTask;
    private SavedGamesDAO savedGamesDAO;

    BrowsePgnPresenter(BrowsePgnContract.View view, SavedGamesDAO savedGamesDAO, String filePath) {
        this.view = view;
        this.savedGamesDAO = savedGamesDAO;
        this.filePath = filePath;
        this.view.setPresenter(this);
    }

    @Override
    public void start() {
        view.showLoading(true);
        loadGamesTask = new LoadGames();
        loadGamesTask.execute(filePath);
    }

    @Override
    public void loadGame(PGNGame game) {
        view.showGame(game.getId());
    }

    @Override
    public void stop() {
        if (loadGamesTask != null) {
            loadGamesTask.cancel(true);
            loadGamesTask = null;
        }
    }

    private class LoadGames extends AsyncTask<String, Void, List<PGNGame>> {

        @Override
        protected List<PGNGame> doInBackground(String... strings) {
            return savedGamesDAO.getGames(filePath);
        }

        @Override
        protected void onPostExecute(List<PGNGame> pgnGames) {
            view.showGames(pgnGames);
            view.showLoading(false);
        }
    }
}
