package chess.mobile.browsepgnfile;

import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.widget.TextView;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import chess.mobile.R;
import chess.mobile.chessgame.pgn.Meta;
import chess.mobile.chessgame.pgn.PGNGame;
import chess.mobile.util.OnItemClickListener;

/**
 * Created 07.07.2017.
 */
class PgnGameViewHolder extends RecyclerView.ViewHolder {

    @BindView(R.id.content) TextView content;
    private OnItemClickListener<PGNGame> onItemClickListener;
    private PGNGame pgnGame;

    PgnGameViewHolder(View itemView, OnItemClickListener<PGNGame> onItemClickListener) {
        super(itemView);
        ButterKnife.bind(this, itemView);
        this.onItemClickListener = onItemClickListener;
    }

    public void bind(PGNGame pgnGame) {
        this.pgnGame = pgnGame;
        String content = "";

        for (Meta m : pgnGame.getMeta()) {
            content += m.getKey() + ": " + m.getValue() + "\n";
        }

        this.content.setText(content.trim());
    }

    @OnClick(R.id.content)
    public void onClick(View v) {
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), pgnGame);
        }
    }
}
