package chess.mobile.dao;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import chess.mobile.chessgame.pgn.Meta;

/**
 * Created by Stanisław Kabaciński.
 */

public class GameMetaDAOImpl implements GameMetaDAO {

    public static final String[] REQUIRED = {
            "White",
            "WhiteElo",
            "Black",
            "BlackElo",
            "Result",
            "ECO",
            "Date",
            "Site",
            "Event",
            "Round",
            "Annotator",
            "Remark"
    };

    private static final GameMetaDAOImpl INSTANCE = new GameMetaDAOImpl();

    public static GameMetaDAO getInstance() {
        return INSTANCE;
    }

    private List<Meta> meta;

    private GameMetaDAOImpl() {
        meta = new ArrayList<>();
        for (String r : REQUIRED) {
            meta.add(new Meta(r, "", true));
        }
    }

    @Override
    public void saveMeta(List<Meta> meta) {
        this.meta = meta;
        List<String> required = new ArrayList<>(Arrays.asList(REQUIRED));
        for (Meta m : meta) {
            if (required.contains(m.getKey())) {
                required.remove(m.getKey());
            }
        }
        for (String r : required) {
            meta.add(new Meta(r, "", true));
        }
    }

    @Override
    public List<Meta> getMeta() {
        return meta;
    }
}
