package chess.mobile.dao;

import java.util.List;

import chess.mobile.chessgame.pgn.PGNGame;
import chess.mobile.model.SavedGameFileMeta;

/**
 * Created by Stanisław Kabaciński.
 */

public interface SavedGamesDAO {

    void saveChessGame(String name, PGNGame pgnGame, Callback<String> callback);

    void getPgnFilesList(Callback<List<SavedGameFileMeta>> callback);

    PGNGame getTemporalGame();

    void removeTemporalGame();

    PGNGame getGame(int id);

    List<PGNGame> getGames(String path);

    void removeFile(String path, Callback<String> callback);

    interface Callback<T> {
        void onSuccess(T data);

        void onFailure(Exception e);
    }

}
