package chess.mobile.dao;

import android.content.Context;
import android.content.SharedPreferences;

/**
 * Created by Stanisław Kabaciński.
 */

public class UserSettingsDAOImpl implements UserSettingsDAO {

    private static final String SP_NAME = "user_credentials";
    private static final String KEY_TOKEN = "token";
    private static final String KEY_LOGIN = "login";
    private static final String KEY_URL = "url";
    private static final String KEY_INDEX = "idx";

    private SharedPreferences sharedPreferences;

    public UserSettingsDAOImpl(Context context) {
        sharedPreferences = context.getSharedPreferences(SP_NAME, Context.MODE_PRIVATE);
    }

    @Override
    public void setAuthToken(String token) {
        put(KEY_TOKEN, token);
    }

    @Override
    public String getAuthToken() {
        return sharedPreferences.getString(KEY_TOKEN, "");
    }

    @Override
    public void setUrl(String url) {
        put(KEY_URL, url);
    }

    @Override
    public String getUrl() {
        return sharedPreferences.getString(KEY_URL, "http://192.168.1.59:8080");
    }

    @Override
    public void setLogin(String login) {
        put(KEY_LOGIN, login);
    }

    @Override
    public String getLogin() {
        return sharedPreferences.getString(KEY_LOGIN, "");
    }

    @Override
    public void setLastSelectedIndex(int index) {
        sharedPreferences.edit()
                .putInt(KEY_INDEX, index)
                .apply();
    }

    @Override
    public int getLastSelectedIndex() {
        return sharedPreferences.getInt(KEY_INDEX, 0);
    }


    private void put(String key, String value) {
        sharedPreferences.edit()
                .putString(key, value)
                .apply();
    }
}
