package chess.mobile.engineoptions;

import java.util.List;

import chess.mobile.BasePresenter;
import chess.mobile.BaseView;
import chess.mobile.model.engineoptions.EngineOption;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

public interface EngineOptionsContract {

    interface View extends BaseView<Presenter> {

        void showOptions(List<EngineOption> engineOptions);

        void showOptionExecuted(EngineOption object);

        void showOptionsSaved();
    }

    interface Presenter extends BasePresenter, OnItemClickListener<EngineOption> {

        void stop();

        @Override
        void onItemClick(android.view.View v, int position, EngineOption object);

        void save();
    }

}
