package chess.mobile.engineoptions.holder;

import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.widget.TextView;

import butterknife.BindView;
import butterknife.ButterKnife;
import chess.mobile.R;
import chess.mobile.model.engineoptions.EngineOption;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */
public class EngineOptionViewHolder extends RecyclerView.ViewHolder {

    @BindView(R.id.option_name) TextView name;

    protected OnItemClickListener<EngineOption> onItemClickListener;
    protected EngineOption option;

    public EngineOptionViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);
    }

    public void bind(EngineOption option, OnItemClickListener<EngineOption> onItemClickListener) {
        this.onItemClickListener = onItemClickListener;
        this.option = option;
        this.name.setText(option.getName());
    }

}
