package chess.mobile.engineoptions.holder;

import android.view.View;
import android.widget.Button;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import chess.mobile.R;
import chess.mobile.model.engineoptions.EngineOption;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

public class OptionButtonViewHolder extends EngineOptionViewHolder {

    @BindView(R.id.button) Button button;

    public OptionButtonViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);
    }

    @Override
    public void bind(EngineOption option, OnItemClickListener<EngineOption> onItemClickListener) {
        super.bind(option, onItemClickListener);
        button.setText(option.getName());
    }

    @OnClick(R.id.button)
    public void onClick(View v) {
        onItemClickListener.onItemClick(v, getAdapterPosition(), option);
    }

}
