package chess.mobile.engineoptions.holder;

import android.support.v7.widget.SwitchCompat;
import android.view.View;
import android.widget.CompoundButton;

import butterknife.BindView;
import butterknife.ButterKnife;
import chess.mobile.R;
import chess.mobile.model.engineoptions.EngineOption;
import chess.mobile.model.engineoptions.EngineOptionCheck;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

public class OptionCheckViewHolder extends EngineOptionViewHolder implements CompoundButton.OnCheckedChangeListener {

    @BindView(R.id.check) SwitchCompat check;

    public OptionCheckViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);

        check.setOnCheckedChangeListener(this);
    }

    @Override
    public void bind(EngineOption option, OnItemClickListener<EngineOption> onItemClickListener) {
        super.bind(option, onItemClickListener);

        EngineOptionCheck engineOption = (EngineOptionCheck) option;

        check.setChecked(engineOption.isChecked());
    }

    @Override
    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
        ((EngineOptionCheck) option).setChecked(isChecked);
        onItemClickListener.onItemClick(buttonView, getAdapterPosition(), option);
    }
}
