package chess.mobile.engineoptions.holder;

import android.view.View;
import android.widget.AdapterView;
import android.widget.Spinner;

import butterknife.BindView;
import butterknife.ButterKnife;
import chess.mobile.R;
import chess.mobile.model.engineoptions.EngineOption;
import chess.mobile.model.engineoptions.EngineOptionCombo;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

public class OptionComboViewHolder extends EngineOptionViewHolder implements AdapterView.OnItemSelectedListener {

    @BindView(R.id.spinner) Spinner spinner;

    public OptionComboViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);

        spinner.setOnItemSelectedListener(this);
    }

    @Override
    public void bind(EngineOption option, OnItemClickListener<EngineOption> onItemClickListener) {
        super.bind(option, onItemClickListener);

        EngineOptionCombo engineOption =(EngineOptionCombo) option;
        this.spinner.setSelection(engineOption.getSelectedIndex());
    }

    @Override
    public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        EngineOptionCombo engineOption = (EngineOptionCombo) option;
        engineOption.setSelected(position);
    }

    @Override
    public void onNothingSelected(AdapterView<?> parent) {
    }
}
