package chess.mobile.engineoptions.holder;

import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import butterknife.BindView;
import butterknife.ButterKnife;
import chess.mobile.R;
import chess.mobile.model.engineoptions.EngineOption;
import chess.mobile.model.engineoptions.EngineOptionSpin;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

public class OptionSpinViewHolder extends EngineOptionViewHolder implements TextWatcher {

    @BindView(R.id.border_values) TextView borderValues;
    @BindView(R.id.value) EditText value;

    public OptionSpinViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);
        value.addTextChangedListener(this);
    }

    @Override
    public void bind(EngineOption option, OnItemClickListener<EngineOption> onItemClickListener) {
        super.bind(option, onItemClickListener);
        EngineOptionSpin engineOption = (EngineOptionSpin) option;
        this.borderValues.setText(
                itemView.getContext().getString(
                        R.string.border_values, engineOption.getMin(), engineOption.getMax()
                )
        );
        this.value.setText(String.valueOf(engineOption.getCurrent()));
    }


    @Override
    public void beforeTextChanged(CharSequence s, int start, int count, int after) {

    }

    @Override
    public void onTextChanged(CharSequence s, int start, int before, int count) {

    }

    @Override
    public void afterTextChanged(Editable s) {
        try {
            ((EngineOptionSpin) option).setCurrent(Integer.valueOf(s.toString()));
        } catch (NumberFormatException e) {
            Log.d(getClass().getSimpleName(), "Number format exception", e);
        }
    }
}
