package chess.mobile.engineoptions.holder;

import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.EditText;

import butterknife.BindView;
import butterknife.ButterKnife;
import chess.mobile.R;
import chess.mobile.model.engineoptions.EngineOption;
import chess.mobile.model.engineoptions.EngineOptionString;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

public class OptionTextViewHolder extends EngineOptionViewHolder implements TextWatcher {

    @BindView(R.id.text) EditText text;

    public OptionTextViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);

        text.addTextChangedListener(this);
    }

    @Override
    public void bind(EngineOption option, OnItemClickListener<EngineOption> onItemClickListener) {
        super.bind(option, onItemClickListener);
        EngineOptionString engineOption = (EngineOptionString) option;
        text.setText(engineOption.getValue());
    }

    @Override
    public void beforeTextChanged(CharSequence s, int start, int count, int after) {

    }

    @Override
    public void onTextChanged(CharSequence s, int start, int before, int count) {

    }

    @Override
    public void afterTextChanged(Editable s) {
        EngineOptionString engineOption = (EngineOptionString) option;
        engineOption.setValue(s.toString());
    }
}
