package chess.mobile.engineoutput;

import chess.mobile.BasePresenter;
import chess.mobile.BaseView;
import chess.mobile.model.UciInfo;

/**
 * Created by Stanisław Kabaciński.
 */

public interface EngineOutputContract {

    interface View extends BaseView<Presenter> {

        void setEngineName(String engineName);

        void showEnginesList();

        void showOutput(String line);

        boolean isActive();


        void showOptions();

        void showOptionsNotReadyError();

        void showNoEngineSelected();

        void showEngineBooting();

        void showEngineRunning();

        void showEngineIdle();

        void showDepthAndEvaluation(int cp, int depth);

        void showEngineNotReadyError();
    }

    interface Presenter extends BasePresenter {

        void stop();

        void onEngineChanged(String engineName);

        void onMessageReceived(String message);

        void onInfoReceived(UciInfo info);

        void run();

        void pause();

        void showOptions();

    }

}
