package chess.mobile.engineoutput;

import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.widget.TextView;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import chess.mobile.R;
import chess.mobile.model.Engine;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */
public class EngineViewHolder extends RecyclerView.ViewHolder {

    @BindView(R.id.engine_name) TextView name;
    @BindView(R.id.status) TextView status;
    @BindView(R.id.description) TextView description;

    private OnItemClickListener<Engine> onItemClickListener;
    private Engine engine;

    public EngineViewHolder(
            View itemView,
            OnItemClickListener<Engine> onItemClickListener
    ) {
        super(itemView);
        this.onItemClickListener = onItemClickListener;
        ButterKnife.bind(this, itemView);
    }

    public void bind(Engine engine) {
        this.engine = engine;
        name.setText(engine.name);
        status.setText(R.string.available);
        description.setText(engine.description);
    }

    @OnClick(R.id.container)
    public void onClick(View v) {
        if (onItemClickListener != null && engine != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), engine);
        }
    }


}
