package chess.mobile.game;

import chess.mobile.model.UciInfo;

/**
 * Created by Stanisław Kabaciński.
 */

public class BoardPresenter implements BoardFragmentContract.Presenter {

    private BoardFragmentContract.View view;

    public BoardPresenter(BoardFragmentContract.View view) {
        this.view = view;
        view.setPresenter(this);
    }

    @Override
    public void onInfoReceived(UciInfo info) {
        view.showLastEngineLine(info.pv, info.depth, info.cp);
    }

    @Override
    public void start() {
        view.showNoEngineOutput();
    }

}
