package chess.mobile.game;

import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Stanisław Kabaciński.
 */

@SuppressWarnings("unused")
public class FragmentPagerAdapter extends android.support.v4.app.FragmentStatePagerAdapter {

    private List<NamedFragment> fragmentsSet;

    public FragmentPagerAdapter(FragmentManager fm) {
        super(fm);
        fragmentsSet = new ArrayList<>();
    }

    @Override
    public Fragment getItem(int position) {
        return fragmentsSet.get(position).fragment;
    }

    @Override
    public CharSequence getPageTitle(int position) {
        return fragmentsSet.get(position).name;
    }

    @Override
    public int getCount() {
        return fragmentsSet.size();
    }



    public void addFragment(Fragment fragment, String name) {
        NamedFragment nf = new NamedFragment(name, fragment);
        fragmentsSet.add(nf);
    }

    public void removeFragment(int position) {
        fragmentsSet.remove(position);
    }


    private class NamedFragment {

        final String name;

        final Fragment fragment;

        NamedFragment(String name, Fragment fragment) {
            this.name = name;
            this.fragment = fragment;
        }

    }
}
