package chess.mobile.meta;

import java.util.List;

import chess.mobile.BasePresenter;
import chess.mobile.BaseView;
import chess.mobile.chessgame.pgn.Meta;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

public interface AddEditMetaContract {

    interface View extends BaseView<Presenter> {

        void showMeta(List<Meta> meta);

        void addMeta(Meta meta);

        void removeMeta(int position);

        void showAddEditMetaDialog(int position, String key, String value, boolean allowRemove, boolean add);

        void updateMeta(int position);
    }

    interface Presenter extends BasePresenter, OnItemClickListener<Meta> {

        void save();

        void addMeta(String key, String value);

        void updateMeta(int position, String key, String value);

        void removeMeta(int position);

    }
}
