package chess.mobile.meta;

import android.view.View;

import java.util.List;

import chess.mobile.chessgame.pgn.Meta;
import chess.mobile.dao.GameMetaDAO;

/**
 * Created by Stanisław Kabaciński.
 */

public class AddEditMetaPresenter implements AddEditMetaContract.Presenter {

    private AddEditMetaContract.View view;
    private List<Meta> meta;

    public AddEditMetaPresenter(AddEditMetaContract.View view, GameMetaDAO gameMetaDAO) {
        this.meta = gameMetaDAO.getMeta();
        this.view = view;
        this.view.setPresenter(this);
    }

    @Override
    public void save() {

    }

    @Override
    public void addMeta(String key, String value) {
        meta.add(new Meta(key, value));
        view.addMeta(meta.get(meta.size() - 1));
    }

    @Override
    public void updateMeta(int position, String key, String value) {
        Meta m = meta.get(position);
        m.setKey(key);
        m.setValue(value);
        view.updateMeta(position);
    }

    @Override
    public void removeMeta(int position) {
        meta.remove(position);
        view.removeMeta(position);
    }

    @Override
    public void start() {
        view.showMeta(meta);
    }

    @Override
    public void onItemClick(View v, int position, Meta object) {
        view.showAddEditMetaDialog(position, object.getKey(), object.getValue(), object.isRequired(), false);
    }
}
