package chess.mobile.meta;

import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.widget.TextView;

import butterknife.BindView;
import butterknife.ButterKnife;
import chess.mobile.R;
import chess.mobile.chessgame.pgn.Meta;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

public class MetaViewHolder extends RecyclerView.ViewHolder implements View.OnClickListener {

    @BindView(R.id.key) TextView key;
    @BindView(R.id.value) TextView value;

    private OnItemClickListener<Meta> onItemClickListener;
    private Meta meta;

    public MetaViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);
        this.itemView.setOnClickListener(this);
    }

    public void bind(Meta meta, OnItemClickListener<Meta> onItemClickListener) {
        this.onItemClickListener = onItemClickListener;
        this.meta = meta;

        key.setText(meta.getKey());
        value.setText(meta.getValue());
    }

    @Override
    public void onClick(View v) {
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), meta);
        }
    }
}
