package chess.mobile.model;

import chess.mobile.Uci;
import chess.mobile.util.Strings;

/**
 * Created by Stanisław Kabaciński.
 */

public class UciInfo {

    public static UciInfo getUciInfo(String uciString) {
        if (!uciString.startsWith(Uci.INFO) || ! uciString.contains(Uci.info.PV)
                || uciString.contains("upperbound") || uciString.contains("lowerbound")) {
            return null;
        }
        String pv = Strings.getStringBetween(uciString, " " + Uci.info.PV, null).trim();
        Integer depth = Strings.getIntAfterString(uciString, " " + Uci.info.DEPTH);
        Integer cp = Strings.getIntAfterString(uciString, " " + Uci.info.score.CP);
        return new UciInfo(pv, cp, depth);
    }

    public static UciInfo getUciInfo(String uciString, int moveNo) {
        if (!uciString.startsWith(Uci.INFO) || ! uciString.contains(Uci.info.PV)
                || uciString.contains("upperbound") || uciString.contains("lowerbound")) {
            return null;
        }
        String pv = Strings.getStringBetween(uciString, " " + Uci.info.PV, null).trim();
        Integer depth = Strings.getIntAfterString(uciString, " " + Uci.info.DEPTH);
        Integer cp = Strings.getIntAfterString(uciString, " " + Uci.info.score.CP);
        if (cp != null) cp = Math.abs(cp);
        return new UciInfo(pv, cp, depth);
    }

    public String pv;

    public final Integer cp;

    public final Integer depth;

    public UciInfo(String pv, Integer cp, Integer depth) {
        this.pv = pv;
        this.cp = cp;
        this.depth = depth;
    }
}
