package chess.mobile.model.engineoptions;

/**
 * Created by Stanisław Kabaciński.
 */

public abstract class EngineOption {

    public static final int TYPE_CHECK = 1;
    public static final int TYPE_SPIN = 2;
    public static final int TYPE_COMBO = 3;
    public static final int TYPE_BUTTON = 4;
    public static final int TYPE_STRING = 5;

    private int type;
    private String name;

    public EngineOption(int type, String name) {
        this.type = type;
        this.name = name;
    }

    public int getType() {
        return type;
    }

    public String getName() {
        return name;
    }

    public abstract void restore();

    public abstract void save();

    public String asSetOptionUciString() {
        return "setoption name " + getName();
    }

    public abstract boolean isValid();

    public abstract boolean hasChanged();

}
