package chess.mobile.model.engineoptions;

/**
 * Created by Stanisław Kabaciński.
 */

public class EngineOptionCheck extends EngineOption {

    private boolean value;
    private boolean originalValue;

    public EngineOptionCheck(boolean value, String name) {
        super(TYPE_CHECK, name);
        this.originalValue = value;
        this.value = value;
    }

    public boolean isChecked() {
        return value;
    }

    public void setChecked(boolean value) {
        this.value = value;
    }

    @Override
    public void restore() {
        this.value = originalValue;
    }

    @Override
    public void save() {
        this.originalValue = value;
    }

    @Override
    public String asSetOptionUciString() {
        return super.asSetOptionUciString() + " value " + String.valueOf(value);
    }

    @Override
    public boolean isValid() {
        return true;
    }

    @Override
    public boolean hasChanged() {
        return value != originalValue;
    }
}
