package chess.mobile.model.engineoptions;

import java.util.List;

/**
 * Created by Stanisław Kabaciński.
 */

public class EngineOptionCombo extends EngineOption {

    private List<String> variants;
    private String selected;
    private String previousSelected;

    public EngineOptionCombo(List<String> variants, String selected, String name) {
        super(TYPE_COMBO, name);
        this.variants = variants;
        this.selected = selected;
        this.previousSelected = selected;
    }

    public List<String> getVariants() {
        return variants;
    }

    public String getSelected() {
        return selected;
    }

    public int getSelectedIndex() {
        return variants.indexOf(selected);
    }

    public void setSelected(String selected) {
        this.selected = selected;
    }

    public void setSelected(int index) {
        this.selected = variants.get(index);
    }

    @Override
    public void restore() {
        this.selected = previousSelected;
    }

    @Override
    public void save() {
        this.previousSelected = selected;
    }

    @Override
    public String asSetOptionUciString() {
        return super.asSetOptionUciString() + " value " + selected;
    }

    @Override
    public boolean isValid() {
        return variants.contains(selected);
    }

    @Override
    public boolean hasChanged() {
        return !selected.equals(previousSelected);
    }
}
