package chess.mobile.model.engineoptions;

/**
 * Created by Stanisław Kabaciński.
 */

public class EngineOptionSpin extends EngineOption {

    private int previousCurrent;
    private int current;
    private int max;
    private int min;

    public EngineOptionSpin(int current, int max, int min, String name) {
        super(TYPE_SPIN, name);
        previousCurrent = current;
        this.current = current;
        this.max = max;
        this.min = min;
    }

    public int getCurrent() {
        return current;
    }

    public void setCurrent(int current) {
        this.current = current;
    }

    public int getMax() {
        return max;
    }

    public int getMin() {
        return min;
    }

    @Override
    public void restore() {
        this.current = previousCurrent;
    }

    @Override
    public void save() {
        this.previousCurrent = current;
    }

    @Override
    public String asSetOptionUciString() {
        return super.asSetOptionUciString() + " value " + String.valueOf(current);
    }

    @Override
    public boolean isValid() {
        return min <= current && current <= max;
    }

    @Override
    public boolean hasChanged() {
        return current != previousCurrent;
    }
}
