package chess.mobile.model.engineoptions;

/**
 * Created by Stanisław Kabaciński.
 */

public class EngineOptionString extends EngineOption {

    private String previousValue;
    private String value;

    public EngineOptionString(String name, String value) {
        super(TYPE_STRING, name);
        previousValue = value;
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @Override
    public void restore() {
        this.value = previousValue;
    }

    @Override
    public void save() {
        this.previousValue = value;
    }

    @Override
    public String asSetOptionUciString() {
        return super.asSetOptionUciString() + " value " + value;
    }

    @Override
    public boolean isValid() {
        return true;
    }

    @Override
    public boolean hasChanged() {
        return !previousValue.equals(value);
    }
}
