package chess.mobile.moveslist;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.TextInputEditText;
import android.support.v4.app.DialogFragment;
import android.view.LayoutInflater;
import android.view.View;

import butterknife.BindView;
import butterknife.ButterKnife;
import chess.mobile.R;

/**
 * Created by Stanisław Kabaciński.
 */

public class CommentDialog extends DialogFragment {

    public static final String KEY_COMMENT_VALUE = "comment";
    public static final String KEY_POSITION = "position";
    public static final String KEY_REMOVED = "removed";

    @BindView(R.id.comment) TextInputEditText comment;

    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        View v = LayoutInflater.from(getContext()).inflate(R.layout.dialog_comment, null, false);

        ButterKnife.bind(this, v);

        Bundle arguments = getArguments();
        int position = arguments.getInt(KEY_POSITION);
        String value = arguments.getString(KEY_COMMENT_VALUE, "");
        comment.setText(value);

        AlertDialog.Builder builder = new AlertDialog.Builder(getContext());
        builder.setTitle(R.string.comment)
                .setView(v)
                .setPositiveButton(R.string.add, (dialog, which) -> {
                    Intent data = new Intent();
                    data.putExtra(KEY_COMMENT_VALUE, comment.getText().toString());
                    data.putExtra(KEY_POSITION, position);
                    getTargetFragment().onActivityResult(getTargetRequestCode(), Activity.RESULT_OK, data);
                })
                .setNeutralButton(R.string.cancel, ((dialog, which) -> {
                    dialog.dismiss();
                }))
                .setNegativeButton(R.string.remove, ((dialog, which) -> {
                    Intent data = new Intent();
                    data.putExtra(KEY_POSITION, position);
                    data.putExtra(KEY_COMMENT_VALUE, comment.getText().toString());
                    data.putExtra(KEY_REMOVED, true);
                    getTargetFragment().onActivityResult(getTargetRequestCode(), Activity.RESULT_OK, data);
                }));


        return builder.create();
    }
}
