package chess.mobile.moveslist;

import android.view.View;
import android.widget.TextView;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import chess.mobile.R;
import chess.mobile.chessgame.Comment;
import chess.mobile.chessgame.Entity;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

class CommentViewHolder extends EntityViewHolder implements View.OnClickListener {

    private OnItemClickListener<Entity> onItemClickListener;

    @BindView(R.id.comment) TextView comment;

    private Comment model;

    CommentViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);
        itemView.setOnClickListener(this);
    }

    public void bind(Comment model, OnItemClickListener<Entity> onItemClickListener, int depth) {
        super.bind(false, depth);
        this.model = model;
        this.onItemClickListener = onItemClickListener;
        comment.setText(model.getValue());
    }

    @Override
    public void onClick(View v) {
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), model);
        }
    }

    @OnClick(R.id.button)
    void onMenuButtonClick(View v) {
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), model);

        }
    }

}
