package chess.mobile.moveslist;

import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.widget.RelativeLayout;

import butterknife.BindColor;
import butterknife.ButterKnife;
import chess.mobile.R;

/**
 * Created by Stanisław Kabaciński.
 */

class EntityViewHolder extends RecyclerView.ViewHolder implements View.OnClickListener {

    @BindColor(R.color.selected) int colorSelected;
    @BindColor(android.R.color.background_light) int colorNormal;

    EntityViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);
    }

    public void bind(boolean selected, int depth) {
        RelativeLayout background = (RelativeLayout) itemView;
        background.setBackgroundColor(selected ? getHighlightColor() : getBackgroundColor());

        if (depth > 4) {
            depth = 4;
        }

        final int d = depth;
        background.post(() -> {
            background.setPadding(d * background.getWidth() / 10, 0, 0, 0);
        });

    }

    protected int getHighlightColor() {
        return colorSelected;
    }

    protected int getBackgroundColor() {
        return colorNormal;
    }

    @Override
    public void onClick(View v) {

    }
}
