package chess.mobile.moveslist;

import android.view.View;
import android.widget.TextView;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import chess.mobile.R;
import chess.mobile.chessgame.Comment;
import chess.mobile.chessgame.Entity;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

class GameBeginViewHolder extends EntityViewHolder implements View.OnClickListener {

    private OnItemClickListener<Entity> onItemClickListener;

    @BindView(R.id.comment) TextView comment;

    GameBeginViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);
        itemView.setOnClickListener(this);
    }

    public void bind(OnItemClickListener<Entity> onItemClickListener, int depth, boolean selected) {
        super.bind(selected, depth);
        this.onItemClickListener = onItemClickListener;
        comment.setText(R.string.game_begin);
    }

    @Override
    public void onClick(View v) {
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), null);
        }
    }

    @OnClick(R.id.button)
    void onMenuButtonClick(View v) {
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), null);

        }
    }

}
