package chess.mobile.moveslist;

import android.text.Html;
import android.view.View;
import android.widget.TextView;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import chess.mobile.R;
import chess.mobile.chessgame.Entity;
import chess.mobile.chessgame.Move;
import chess.mobile.chessgame.NumericAnnotationGlyph;
import chess.mobile.chessgame.SANHelper;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */

class MoveViewHolder extends EntityViewHolder implements View.OnClickListener {

    private OnItemClickListener<Entity> onItemClickListener;

    @BindView(R.id.move_number) TextView moveNumber;
    @BindView(R.id.move) TextView move;

    @BindView(R.id.bar) View bar;

    private Move model;

    public MoveViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);
        itemView.setOnClickListener(this);
    }

    public void bind(Move move, OnItemClickListener<Entity> onItemClickListener, int depth, String moveNo, boolean selected) {
        super.bind(selected, depth);
        this.onItemClickListener = onItemClickListener;
        this.model = move;
        moveNumber.setText(moveNo);
        moveNumber.setVisibility(View.VISIBLE);
        this.move.setText(Html.fromHtml(
                SANHelper.replaceLettersWithSymbols(model.getSan(), model.getColor()) + " " + NumericAnnotationGlyph.getAsString(model.getNags())));
    }

    @Override
    public void onClick(View v) {
        super.onClick(v);
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), model);
        }
    }

    @OnClick(R.id.button)
    void onMenuButtonClick(View v) {
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), model);

        }
    }
}
