package chess.mobile.moveslist;

import android.view.View;
import android.widget.TextView;

import butterknife.BindColor;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import chess.mobile.R;
import chess.mobile.chessgame.Entity;
import chess.mobile.util.OnItemClickListener;

/**
 * Created by Stanisław Kabaciński.
 */
public class VariantViewHolder extends EntityViewHolder implements View.OnClickListener {

    public static final int TYPE_BEGIN = 0;
    public static final int TYPE_END = 1;

    @BindView(R.id.text) TextView text;
    @BindColor(R.color.lightGrey) int backgroundColor;
    @BindColor(R.color.selectedVariant) int selectedColor;
    private OnItemClickListener<Entity> onItemClickListener;

    private Entity model;

    public VariantViewHolder(View itemView) {
        super(itemView);
        ButterKnife.bind(this, itemView);
    }

    public void bind(int variantType, OnItemClickListener<Entity> onItemClickListener, int depth, Entity entity, boolean selected) {
        super.bind(selected, depth);
        this.model = entity;
        this.onItemClickListener = onItemClickListener;
        text.setText(variantType == TYPE_BEGIN ? R.string.variant_begin : R.string.variant_end);
    }

    @Override
    protected int getHighlightColor() {
        return selectedColor;
    }

    @Override
    protected int getBackgroundColor() {
        return backgroundColor;
    }

    @OnClick(R.id.button)
    void onMenuButtonClick(View v) {
        if (onItemClickListener != null) {
            onItemClickListener.onItemClick(v, getAdapterPosition(), model);

        }
    }
}
