package chess.mobile.rest;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * Created 27.02.2017.
 */

public class ApiCallback<T> implements Callback<T> {

    private ResponseListener<T> responseListener;

    public ApiCallback(ResponseListener<T> responseListener) {
        this.responseListener = responseListener;
    }

    @Override
    public void onResponse(Call<T> call, Response<T> response) {
        if (response.isSuccessful()) {
            responseListener.onRequestSuccess(response.body());
        } else {
            responseListener.onRequestFailure(new RuntimeException(String.valueOf(response.code())));
        }
    }

    @Override
    public void onFailure(Call<T> call, Throwable t) {
        responseListener.onRequestFailure(new RuntimeException(t));
        t.printStackTrace();
    }

}
