package chess.mobile.rest;
import java.io.IOException;

import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

/**
 * Created 07.02.2017.
 */

public class AuthenticationInterceptor implements Interceptor {

    private String authToken;

    public AuthenticationInterceptor(String authToken) {
        this.authToken = authToken;
    }

    @Override
    public Response intercept(Chain chain) throws IOException {
        Request request = chain.request();

        Request.Builder builder = request.newBuilder()
                .header("Authorization", "Bearer " + authToken);

        Request updated = builder.build();
        return chain.proceed(updated);
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof AuthenticationInterceptor
                && authToken.contentEquals(((AuthenticationInterceptor) obj).authToken);
    }

}
