package chess.mobile.rest;

import chess.mobile.model.EnginesList;
import chess.mobile.model.Position;
import chess.mobile.model.StartEngine;
import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.POST;

/**
 * Created by Stanisław Kabaciński.
 */

public interface EngineService {

    @GET("/engine/available")
    Call<EnginesList> getEnginesList();

    @POST("/engine/start")
    Call<Response> startEngine(
            @Body StartEngine engine
    );

    @POST("/engine/stop")
    Call<Response> stopEngine();

    @POST("/engine/command/set_position")
    Call<Response> setPosition(
            @Body Position position
    );

}
