package chess.mobile.util;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import chess.mobile.chessgame.pgn.Meta;
import chess.mobile.dao.GameMetaDAOImpl;

/**
 * Created 24.09.2017.
 */

public class MetadataOrderer {

    public static List<Meta> order(List<Meta> list) {
        List<String> order = Arrays.asList(GameMetaDAOImpl.REQUIRED);
        List<Meta> nonRequired = new ArrayList<>();
        List<Meta> required = new ArrayList<>();
        for (Meta m : list) {
            if (order.contains(m.getKey())) {
                required.add(m);
            } else {
                nonRequired.add(m);
            }
        }

        Collections.sort(required, (a, b) -> {
            Integer aPosition = order.indexOf(a.getKey());
            Integer bPosition = order.indexOf(b.getKey());
            return aPosition.compareTo(bPosition);
        });

        list.clear();
        list.addAll(required);
        list.addAll(nonRequired);
        return list;
    }

}
