package chess.mobile.chessgame;

import org.junit.Test;

import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.assertArrayEquals;

/**
 * Created by Stanisław Kabaciński.
 */
public class MovesFilterTest {

    @Test
    public void filterVariantInside() throws Exception {
        Move m;
        List<Entity> entities = new ArrayList<>();
        List<Move> expectedOutput = new ArrayList<>();
        List<Move> output;

        m = new Move();
        entities.add(m);
        expectedOutput.add(m);

        entities.add(new Comment());
        m = new Move();
        entities.add(m);

        entities.add(new VariantBegin());

        m = new Move();
        entities.add(m);
        expectedOutput.add(m);

        entities.add(new VariantBegin());

        m = new Move();
        entities.add(m);

        entities.add(new VariantEnd());

        m = new Move();
        entities.add(m);
        expectedOutput.add(m);

        output = MovesFilter.filter(entities);

        assertArrayEquals(expectedOutput.toArray(), output.toArray());
    }

    @Test
    public void filterNestedVariant() throws Exception {
        Move m;
        List<Entity> entities = new ArrayList<>();
        List<Move> expectedOutput = new ArrayList<>();
        List<Move> output;

        m = new Move();
        entities.add(m);
        expectedOutput.add(m);

        entities.add(new Comment());
        m = new Move();
        entities.add(m);

        entities.add(new VariantBegin());

        m = new Move();
        entities.add(m);

        entities.add(new VariantBegin());

        m = new Move();
        entities.add(m);
        expectedOutput.add(m);


        output = MovesFilter.filter(entities);

        assertArrayEquals(expectedOutput.toArray(), output.toArray());
    }

}