package chess.mobile.chessgame;

import org.junit.Test;

import static org.junit.Assert.*;

/**
 * Created by Stanisław Kabaciński.
 */
public class SANHelperTest {
    @Test
    public void getSanFromLAN() throws Exception {
        ChessGame chessGame = new ChessGameImpl();

        String san = SANHelper.getSanFromLAN("a2a4 a7a5 b2b4", chessGame.clone());

        assertEquals("1. a4 a5 2. b4", san);

        MoveFactory factory = new MoveFactory(new PossibleMovesProviderImpl(chessGame));
        Move m = factory.getMove(chessGame.getBoard(), 7, 1, 7, 2);
        chessGame.makeMove(m);

        san = SANHelper.getSanFromLAN("a2a4 a7a5 b2b4", chessGame.clone());
        assertEquals("1… a4 2. a5 b4", san);
    }

    @Test
    public void replaceSymbolsWithLetters() throws Exception {
        String s = "xb3=&#9812;";
        String expected = "xb3=K";

        String actual = SANHelper.replaceSymbolsWithLetters(s);
        assertEquals(expected, actual);

        s = "&#9812;xb3";
        expected = "Kxb3";

        actual = SANHelper.replaceSymbolsWithLetters(s);
        assertEquals(expected, actual);
    }

}